#!/usr/bin/env python
# -*- coding: cp1252 -*-

from Bio import SeqIO
import sys




def pos_sans_align(posalignstop,seq,possansalignstop):
	index=[]
	cpt=0
	for i in seq:
		index.append(cpt)
		if i !='-':
			cpt+=1
		
	for pos in posalignstop:
		possansalignstop.append(index[pos])




def repartition(poslist,c1):
		for pos in poslist:
			if pos%3==0:
				c1.append(pos)





def longueurASP(sequence):
	stop=[]
	start=[]
	l=0
	longueur=0
	for i in range(0,len(sequence),3):
		if sequence[i:i+3]=='TAA' or sequence[i:i+3]=='TAG' or sequence[i:i+3]=='TGA':
			stop.append(i)
		if sequence[i:i+3]=='ATG':
			start.append(i)


	if len(stop)!=0 and len(start)!=0:
		for i in range(len(start)):
			x=0
			while stop[x]<start[i] and x<len(stop)-1:
				x+=1
			if stop[x]-start[i]>longueur:
				longueur=stop[x]-start[i]
		
	
	else:
		if len(start)!=0:
			longueur=len(sequence)-start[0]
	

	return longueur/3




#programme principal

handle = open(sys.argv[1],"rU")
#recup pos stop
posstop=[]

seq={}
for record in SeqIO.parse(handle, "fasta") :
	sequence=record.seq[2:-1]
	sequence=str(sequence.reverse_complement())
	seq[record.id]=sequence
handle.close()



listlength={}
for acc in seq.keys():
	listlength[acc]=longueurASP(seq[acc])

nb=0
for acc in listlength.keys():
	if listlength[acc]>=150:
		nb+=1
print float(nb)/len(listlength)
	
handle.close()
