#!/usr/bin/env python
# -*- coding: cp1252 -*-
#~ from __future__ import print_function

from Bio.Seq import Seq
from Bio import SeqIO
from Bio.Alphabet import generic_dna
import sys
import csv
#ASP position
reader = csv.reader(open(sys.argv[1],"rU"), delimiter=' ')
pos=[]
for row in reader:
	pos.append([int(row[0]), int(row[1])])

x=int(sys.argv[3])

for maSeqRecord in SeqIO.parse(sys.argv[2], "fasta"):
	if x==1:
		maSeqRecord.seq=Seq(str(maSeqRecord.seq)[pos[3][0]:pos[3][1]])
	if x==2:
		maSeqRecord.seq=Seq(str(maSeqRecord.seq)[pos[1][0]:pos[1][1]]+ str(maSeqRecord.seq)[pos[2][0]:pos[2][1]] )
	if x==3:
		maSeqRecord.seq=Seq(str(maSeqRecord.seq)[pos[0][0]:pos[1][0]]+str(maSeqRecord.seq)[pos[1][1]:pos[2][0]]+str(maSeqRecord.seq)[pos[2][1]:pos[3][0]])
	if x==4:
		maSeqRecord.seq=Seq(str(maSeqRecord.seq)[pos[0][0]:pos[0][1]])
	
	print maSeqRecord.format('fasta')


