#!/usr/bin/perl

#BEGIN{foreach (@INC) {s/\/usr\/local\/packages/\/local\/platform/}};
#use lib (@INC,$ENV{"PERL_MOD_DIR"});
#no lib "$ENV{PERL_MOD_DIR}/i686-linux";
#no lib ".";

=head1 NAME

supgapfasta.pl - supprime gap only column

=head1 SYNOPSIS

USAGE: supgapfasta.pl 
            --input_file=/path/to/some_file.fasta
    

=cut


use Bio::AlignIO;
use Bio::SimpleAlign;

my $str = Bio::AlignIO->new(-file => $ARGV[0]);
my $aln = $str->next_aln();
my $aln2=$aln->remove_gaps('-',1);


my $OUTSTREAM = Bio::AlignIO->newFh('-format' => 'fasta',
                                    '-fh'     => \*STDOUT
                                   );
print $OUTSTREAM $aln2;

1;
