#!/usr/bin/env python
# -*- coding: cp1252 -*-

import sys
import dendropy

# This script randomly rotates the branches around the internal nodes in the phylogenetic tree in order to test the stability of the results.

tree=dendropy.Tree.get_from_path(sys.argv[1], schema="newick")
dendropy.treemanip.randomly_rotate(tree, rng=None)
tree.write_to_path('treetmp.tree','newick')
